"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
/* eslint-disable no-console */
var fs = __importStar(require("fs"));
var path = __importStar(require("path"));
var manifest_1 = require("../services/manifest");
var console_1 = require("../services/console");
var constants_1 = require("../services/constants");
var utils_1 = require("../utils/utils");
function build(program, projectPath) {
    return __awaiter(this, void 0, void 0, function () {
        var verbosity, logger, manifest, buildPath, inFile, outFile;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    verbosity = program.opts().verbose;
                    logger = new console_1.Logger(verbosity);
                    logger.verbose('Building project');
                    manifest = (0, manifest_1.validateAndReadManifest)(logger, program, projectPath);
                    validateIsWasmProject(program, manifest);
                    buildPath = prepareBuildPath(logger, projectPath);
                    inFile = path.join(projectPath, 'src', 'index.ts');
                    outFile = path.join(buildPath, 'index.wasm');
                    return [4 /*yield*/, buildAssemblyScript(logger, program, inFile, outFile, projectPath)
                        // await checkAssemblyScriptBuild(logger, program, outFile)
                    ];
                case 1:
                    _a.sent();
                    // await checkAssemblyScriptBuild(logger, program, outFile)
                    (0, manifest_1.serializeAndSaveManifest)(logger, manifest, buildPath);
                    logger.ok('Done!');
                    return [2 /*return*/];
            }
        });
    });
}
function prepareBuildPath(logger, projectPath) {
    var p = path.join(projectPath, constants_1.OUT_DIR);
    logger.verbose("Preparing build path ".concat(p));
    if (fs.existsSync(p)) {
        fs.rmSync(p, { recursive: true, force: true });
    }
    fs.mkdirSync(p);
    return p;
}
function validateIsWasmProject(program, manifest) {
    if (manifest.type !== 'wasm') {
        program.error('Oops, nothing to build for SQL based daemons');
    }
}
function buildAssemblyScript(logger, program, inFile, outFile, projectPath) {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    logger.ok('Compiling source code');
                    if (!fs.existsSync(inFile))
                        program.error("Input File \"".concat(inFile, "\" not found"));
                    return [4 /*yield*/, (0, utils_1.runCommand)("npm run build --prefix \"".concat(projectPath, "\""))
                        // const result = await asc
                        //     .main([
                        //         inFile,
                        //         '--exportRuntime',
                        //         // Stub runtime, does not implement garbage collection
                        //         '--runtime',
                        //         'stub',
                        //         '--lib',
                        //         '--outFile',
                        //         outFile,
                        //         '--optimize',
                        //         '--noAssert',
                        //         '--sourceMap',
                        //         '--path',
                        //         `"${path.join(projectPath, 'node_modules')}"`,
                        //     ])
                        //     .then((result) => {
                        //         logger.verbose('Compilation finished')
                        //         return 0
                        //     })
                        //     .catch((error) => {
                        //         logger.verbose('Compilation failed with error')
                        //         console.error(error)
                        //         program.error('Compilation failed')
                        //     })
                    ];
                case 1:
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    });
}
function checkAssemblyScriptBuild(logger, program, outFile) {
    return __awaiter(this, void 0, void 0, function () {
        var compiledModuleContent, wasmModule;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    compiledModuleContent = fs.readFileSync(outFile);
                    return [4 /*yield*/, WebAssembly.instantiate(compiledModuleContent, {
                            crypto: {
                                ripemd128: function () {
                                    console.log('Stub implementation');
                                },
                                ripemd160: function () {
                                    console.log('Stub implementation');
                                },
                                ripemd256: function () {
                                    console.log('Stub implementation');
                                },
                                ripemd320: function () {
                                    console.log('Stub implementation');
                                },
                                sha2_224: function () {
                                    console.log('Stub implementation');
                                },
                                sha2_256: function () {
                                    console.log('Stub implementation');
                                },
                                sha2_384: function () {
                                    console.log('Stub implementation');
                                },
                                sha2_512: function () {
                                    console.log('Stub implementation');
                                },
                                sha_512_224: function () {
                                    console.log('Stub implementation');
                                },
                                sha_512_256: function () {
                                    console.log('Stub implementation');
                                },
                                sha3_224: function () {
                                    console.log('Stub implementation');
                                },
                                sha3_256: function () {
                                    console.log('Stub implementation');
                                },
                                sha3_384: function () {
                                    console.log('Stub implementation');
                                },
                                sha3_512: function () {
                                    console.log('Stub implementation');
                                },
                            },
                            format: {
                                json_parse: function () {
                                    console.log('Stub implementation');
                                },
                                json_stringify: function () {
                                    console.log('Stub implementation');
                                },
                                yaml_parse: function () {
                                    console.log('Stub implementation');
                                },
                                yaml_stringify: function () {
                                    console.log('Stub implementation');
                                },
                                hex_encode: function () {
                                    console.log('Stub implementation');
                                },
                                hex_decode: function () {
                                    console.log('Stub implementation');
                                },
                                base58_encode: function () {
                                    console.log('Stub implementation');
                                },
                                base58_decoding: function () {
                                    console.log('Stub implementation');
                                },
                                base64_encode: function () {
                                    console.log('Stub implementation');
                                },
                                base64_decode: function () {
                                    console.log('Stub implementation');
                                },
                                rlp_encode: function () {
                                    console.log('Stub implementation');
                                },
                                rlp_decode: function () {
                                    console.log('Stub implementation');
                                },
                            },
                            log: {
                                log: function () {
                                    console.log('Stub implementation');
                                },
                            },
                            store: {
                                save: function () {
                                    console.log('Stub implementation');
                                },
                                load: function () {
                                    console.log('Stub implementation');
                                },
                                load_reference: function () {
                                    console.log('Stub implementation');
                                },
                                get_next_id: function () {
                                    console.log('Stub implementation');
                                },
                            },
                            env: {
                                abort: function () {
                                    console.log('Stub implementation');
                                },
                            },
                        })];
                case 1:
                    wasmModule = _a.sent();
                    if (!wasmModule.instance.exports['main']) {
                        program.error("Method 'main' is not found in module");
                    }
                    return [2 /*return*/];
            }
        });
    });
}
exports.default = {
    build: build,
};
//# sourceMappingURL=build.js.map