"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Logger = void 0;
/* eslint-disable no-console */
var colors_1 = __importDefault(require("colors"));
var Logger = /** @class */ (function () {
    function Logger(level) {
        this.level = level;
    }
    Logger.prototype.verbose = function () {
        var rest = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            rest[_i] = arguments[_i];
        }
        if (process.env.NODE_ENV === 'test')
            return;
        if (this.level > 0) {
            var args = rest.map(function (arg) { return colors_1.default.grey(arg); });
            console.log.apply(console, args);
        }
    };
    Logger.prototype.ok = function () {
        var rest = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            rest[_i] = arguments[_i];
        }
        if (process.env.NODE_ENV === 'test')
            return;
        var args = rest.map(function (arg) { return colors_1.default.green(arg); });
        console.log.apply(console, args);
    };
    Logger.prototype.log = function () {
        var rest = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            rest[_i] = arguments[_i];
        }
        if (process.env.NODE_ENV === 'test')
            return;
        console.log.apply(console, rest);
    };
    return Logger;
}());
exports.Logger = Logger;
//# sourceMappingURL=console.js.map